#!/usr/local/bin/perl
# disable_domain.cgi
# Temporarily disable a domain, after asking first
# XXX comment out apache section? or add redirect directive?
# XXX disable webmin user (no password)
# XXX leave mail enabled
# XXX disable mysql and postgresql logins
# XXX disable DNS domain in named.conf, but leave file

require './virtual-server-lib.pl';
&ReadParse();
$d = &get_domain($in{'dom'});
$access{'edit'} && &can_edit_domain($d) || &error($text{'edit_ecannot'});
$d->{'disabled'} && &error($text{'disable_ealready'});

&header($text{'disable_title'}, "");
print "<hr>\n";

if (!$in{'confirm'}) {
	# Ask the user if he is sure
	print &check_clicks_function();
	print "<p>",&text('disable_rusure', "<tt>$d->{'dom'}</tt>"),"<p>\n";
	print $text{'disable_undo'},"<p>\n";
	print "<center><form action=disable_domain.cgi>\n";
	print "<input type=hidden name=dom value='$in{'dom'}'>\n";
	print "<input type=submit name=confirm ",
	      "value='$text{'disable_ok'}' onClick='check_clicks(form)'>\n";
	print "</form></center>\n";
	}
else {
	# Go ahead and do it ..

	# Run the before command
	&set_domain_envs($d, "DISABLE_DOMAIN");
	$merr = &making_changes();
	&error(&text('disable_emaking', "<tt>$merr</tt>")) if (defined($merr));

	# Lock the Unix user's account
	&require_useradmin();
	local @allusers = &useradmin::list_users();
	local ($uinfo) = grep { $_->{'user'} eq $d->{'user'}} @allusers;
	if ($uinfo) {
		print $text{'disable_unix'},"<br>\n";
		&useradmin::set_user_envs($uinfo, 'MODIFY_USER', "")
			if (defined(&useradmin::set_user_envs));
		&useradmin::making_changes();
		$d->{'disabled_oldpass'} = $uinfo->{'pass'};
		$uinfo->{'pass'} = $uconfig{'lock_string'};
		&useradmin::modify_user($uinfo, $uinfo);
		&useradmin::made_changes();
		print $text{'setup_done'},"<p>\n";
		}

	if ($d->{'web'}) {
		# Re-direct website to disabled page
		&disable_apache($d);
		&restart_apache();
		}

	if ($d->{'dns'}) {
		# Delete zone from named.conf, but leave file
		&disable_bind($d);
		&restart_bind();
		}

	if ($d->{'mail'}) {
		# Take mail domain out of accepted list
		&disable_mail($d);
		}

	if ($d->{'mysql'}) {
		# Disable mysql user
		&disable_mysql($d);
		}

	if ($d->{'postgres'}) {
		# Disable postgresql user
		&disable_postgres($d);
		}

	# Save new domain details
	print $text{'save_domain'},"<br>\n";
	$d->{'disabled'} = 1;
	&save_domain($d);
	print $text{'setup_done'},"<p>\n";

	# Run the after command
	&set_domain_envs($d, "DISABLE_DOMAIN");
	&made_changes();
	}

print "<hr>\n";
&footer("edit_domain.cgi?dom=$in{'dom'}", $text{'edit_return'},
	"", $text{'index_return'});

