#!/usr/local/bin/perl
# save_alias.cgi
# Create, update or delete an alias

require './virtual-server-lib.pl';
&ReadParse();
$d = &get_domain($in{'dom'});
&can_edit_domain($d) || &error($text{'aliases_ecannot'});
@aliases = &list_domain_aliases($d);
if (!$in{'new'}) {
	($virt) = grep { $_->{'from'} eq $in{'old'} } @aliases;
	%oldvirt = %$virt;
	}
&error_setup($text{'alias_err'});

if ($in{'delete'}) {
	# Just delete the virtuser
	&delete_virtuser($virt);
	}
else {
	# Verify inputs
	$in{'name_def'} || $in{'name'} =~ /^[A-Za-z0-9\.\-\_]+$/ ||
		&error($text{'alias_ename'});
	$name = $in{'name_def'} ? "" : $in{'name'};
	$virt->{'from'} = $name."\@".$d->{'dom'};
	for($i=0; defined($t = $in{"type_$i"}); $i++) {
		$v = $in{"val_$i"};
		$v =~ s/^\s+//;
		$v =~ s/\s+$//;
		if ($t == 1 && $v !~ /^(\S+)$/) {
			&error(&text('alias_etype1', $v));
			}
		elsif ($t == 2 && !&check_aliasfile($v, 1)) {
			&error(&text('alias_etype2', $v));
			}
		elsif ($t == 3 && $v !~ /^\/(\S+)$/) {
			&error(&text('alias_etype3', $v));
			}
		elsif ($t == 4) {
			$v =~ /^(\S+)/ || &error($text{'alias_etype4none'});
			(-x $1) && &check_aliasfile($1, 0) ||
				&error(&text('asave_etype4', $1));
			}
		elsif ($t == 5 && !&check_aliasfile($v, 1)) {
			&error(&text('alias_etype5', $v));
			}
		elsif ($t == 6 && !&check_aliasfile($v, 1)) {
			&error(&text('asave_etype6', $v));
			}
		elsif ($t == 7 && !defined(getpwnam($v))) {
			&error(&text('asave_etype7', $v));
			}
		if ($t == 1 || $t == 3) { push(@values, $v); }
		elsif ($t == 2) { push(@values, ":include:$v"); }
		elsif ($t == 4) { push(@values, "|$v"); }
		elsif ($t == 5) {
			# Setup autoreply script
			push(@values, "|$module_config_directory/autoreply.pl ".
				      "$v $name");
			&system_logged("cp autoreply.pl $module_config_directory");
			&system_logged("chmod 755 $module_config_directory/config");
			if (-d $sconfig{'smrsh_dir'}) {
				&system_logged("ln -s $module_config_directory/autoreply.pl $config{'smrsh_dir'}/autoreply.pl");
				}
			}
		elsif ($t == 6) {
			# Setup filter script
			push(@values, "|$module_config_directory/filter.pl ".
				      "$v $name");
			&system_logged("cp filter.pl $module_config_directory");
			&system_logged("chmod 755 $module_config_directory/config");
			if (-d $sconfig{'smrsh_dir'}) {
				&system_logged("ln -s $module_config_directory/filter.pl $config{'smrsh_dir'}/filter.pl");
				}
			}
		elsif ($t == 7) {
			push(@values, "\\$v");
			}
		}
	@values || &error($text{'alias_enone'});
	$virt->{'to'} = \@values;

	if ($in{'new'}) {
		# Check for a clash
		if (&check_clash($name, $d->{'dom'})) {
			&error($text{'alias_eclash'});
			}

		# Create the virtuser
		&create_virtuser($virt);
		}
	else {
		if ($virt->{'from'} ne $in{'old'}) {
			# Has been renamed .. check for a clash
			if (&check_clash($name, $d->{'dom'})) {
				&error($text{'alias_eclash'});
				}
			}

		# Modify virtuser
		&modify_virtuser(\%oldvirt, $virt);
		}
	}
&redirect("list_aliases.cgi?dom=$in{'dom'}");

sub check_aliasfile
{
return 0 if (!-r $_[0] && !$_[1]);
return 1;
}

