#!/usr/local/bin/perl
# save_luser.cgi
# Create, update or delete a local user

require './virtual-server-lib.pl';
&ReadParse();
&require_useradmin();
$access{'local'} || &error($text{'users_ecannot2'});
@users = &list_all_users_quotas();
if (!$in{'new'}) {
	($user) = grep { $_->{'user'} eq $in{'old'} } @users;
	%old = %$user;
	}
&error_setup($text{'luser_err'});

%taken = map { $_->{'uid'}, 1 } @users;
%utaken = map { $_->{'user'}, 1 } @users;

if ($in{'delete'}) {
	# Get rid of his mail file
	&delete_mail_file($user);

	# Just delete this user
	&useradmin::set_user_envs($user, 'DELETE_USER')
		if (defined(&useradmin::set_user_envs));
	&useradmin::making_changes();
	&useradmin::delete_user($user);
	&useradmin::made_changes();

	# Delete home dir
	system("rm -rf '$user->{'home'}'")
	  if (-d $user->{'home'} && $user->{'home'} ne "/");
	}
else {
	# Verify inputs
	$in{'user'} =~ /^[^ \t:]+$/ || &error($text{'user_euser'});
	$in{'real'} =~ /^[^:]*$/ || &error($text{'user_ereal'});
	$user->{'real'} = $in{'real'};
	$user->{'pass'} = &useradmin::encrypt_password($in{'pass'})
		if (!$in{'pass_def'});
	if ($config{'home_quotas'}) {
		if ($in{'quota'} eq -1) { $in{'quota'} = $in{'otherquota'} };
		$in{'quota'} =~ /^\d+$/ || &error($text{'user_equota'});
		}

	# Decide on home dir
	local $home =  &useradmin::auto_home_dir($uconfig{'home_base'},
						 $in{'user'});

	# Create or update the user
	if ($in{'new'}) {
		# Set new user parameters
		$user->{'uid'} = $uconfig{'base_uid'};
		while($taken{$user->{'uid'}}) {
			$user->{'uid'}++;
			}
		if ($utaken{$in{'user'}}) {
			&error($text{'luser_etaken'});
			}
		$user->{'user'} = $in{'user'};
		@gr = getgrnam($config{'localgroup'});
		$user->{'gid'} = $gr[2];
		$user->{'shell'} = $in{'ftp'} ? $config{'ftp_shell'}
					      : $config{'shell'};
		$user->{'home'} = $home;
		$user->{'passmode'} = 3;
		$user->{'plainpass'} = $in{'pass'};

		# Create the user
		&useradmin::set_user_envs($user, 'CREATE_USER', $in{'pass'}, [])
			if (defined(&useradmin::set_user_envs));
		&useradmin::making_changes();
		&useradmin::create_user($user);
		&useradmin::made_changes();

		# Create his homedir
		system("mkdir -p '$home'");
		system("chown $user->{'uid'}:$user->{'gid'} '$home'");
		system("chmod 755 '$home'");

		# Copy files into homedir
		&copy_skel_files($config{'local_skel'}, $user);
		}
	else {
		# Update user parameters (handle rename and .group)
		if ($in{'user'} ne $in{'oldpop3'}) {
			# Has been renamed .. check for a username clash
			if ($utaken{$in{'user'}}) {
				&error($text{'luser_etaken'});
				}
			$user->{'user'} = $in{'user'};

			# Rename his mail file
			&rename_mail_file($user, $in{'oldpop3'});

			# Rename homedir
			if ($user->{'home'} ne $home && -d $user->{'home'}) {
				system("mv '$user->{'home'}' '$home'");
				$user->{'home'} = $home;
				}
			}

		# Update shell
		if (defined($in{'ftp'})) {
			$user->{'shell'} = $in{'ftp'} ? $config{'ftp_shell'}
						      : $config{'shell'};
			}

		# Modify the user
		&useradmin::set_user_envs($user, 'MODIFY_USER',
					  $in{'pass_def'} ? "" : $in{'pass'})
			if (defined(&useradmin::set_user_envs));
		&useradmin::making_changes();
		&useradmin::modify_user(\%old, $user);
		&useradmin::made_changes();
		}

	if ($config{'home_quotas'}) {
		# Set his quotas
		&quota::edit_user_quota($user->{'user'},
					$config{'home_quotas'},
					$in{'quota'}, 0, 0, 0);
		}
	}
&redirect("");

