#!/usr/local/bin/perl
# stop_apache.cgi
# Shut down the Apache webserver

require './virtual-server-lib.pl';
$access{'stop'} || &error($text{'stop_ecannot'});
&require_apache();
&error_setup($apache::text{'stop_err'});

if ($aconfig{'stop_cmd'}) {
	# use the configured stop command
	$out = &backquote_logged("( $aconfig{'stop_cmd'} ) 2>&1");
	if ($?) {
		&error("<pre>$out</pre>");
		}
	}
elsif (-x $aconfig{'apachectl_path'}) {
	# use the apachectl program
	$out = &backquote_logged("$aconfig{'apachectl_path'} stop 2>&1");
	if ($httpd_modules{'core'} >= 2 ? $? : $out !~ /httpd stopped/) {
		&error("<pre>$out</pre>");
		}
	}
else {
	# kill the process
	$conf = &apache::get_config();
	$pidfilestr = &apache::find_directive_struct("PidFile", $conf);
	$pidfile = $pidfilestr ? $pidfilestr->{'words'}->[0]
			       : "logs/httpd.pid";
	$pidfile = &apache::server_root($pidfile, $conf);

	open(PID, $pidfile) || &error(&apache::text('stop_epid', $pidfile));
	<PID> =~ /(\d+)/ || &error(&apache::text('stop_epid2', $pidfile));
	close(PID);
	&kill_logged('TERM', $1) || &error(&apache::text('stop_esig', $1));
	}
sleep(1);
&redirect("");

